#ifndef _DocumentSystem_h
#define _DocumentSystem_h

#include "Document.h"

typedef std::list<Document*> DocumentList;


class DocumentSystem
{
public:
	DocumentSystem();
	~DocumentSystem();

	static DocumentSystem& getInstance();

	/*
	 *
	 */
	void append(Document *doc);

	/*
	 *	emit signal_document_delete and	delete the document
	 */
	void remove(Document *doc);

	/*
	 *
	 */
	sigc::signal<void, Document*>& signal_document_create();

	/*
	 *
	 */
	sigc::signal<void, Document*>& signal_document_delete();

	/*
	 *
	 */
	sigc::signal<void, Document*>& signal_current_document_changed();

	/*
	 *
	 */
	void setCurrentDocument(Document *doc);

	/*
	 *
	 */
	Document* getCurrentDocument();

	/*
	 *
	 */
	DocumentList getAllDocuments();

	/*
	 *	filename (getFilename) is used not name (getName)!
	 */
	Document* getDocument(const Glib::ustring &filename);

	/*
	 *	
	 */
	Glib::ustring generate_untitled_name();

protected:
	DocumentList	m_listDocuments;
	
	Document*	m_currentDocument;

	sigc::signal<void, Document*>	m_signal_document_create;
	sigc::signal<void, Document*>	m_signal_document_delete;
	sigc::signal<void, Document*> m_signal_current_document_changed;
};

#endif//_DocumentSystem_h

