#include "Scale.h"

/*
 *
 */
bool Scale::execute(Document &doc, 
		const SubtitleTime &source1, const SubtitleTime &dest1,
		const SubtitleTime &source2, const SubtitleTime &dest2)
{
	double scale = calcul_scale(
			source1.totalmsecs, dest1.totalmsecs,
			source2.totalmsecs, dest2.totalmsecs);

	Gtk::TreeNodeChildren rows = doc.get_subtitle_model()->children();

	for(Gtk::TreeIter it = rows.begin(); it; ++it)
	{
		SubtitleModifier subtitle(it);

		SubtitleTime start = calcul(subtitle.get_start(), scale, source1, dest1);
		SubtitleTime end = calcul(subtitle.get_end(), scale, source1, dest1);

		subtitle.set_start_and_end(start, end);
	}

	doc.emit_signal("subtitle-time-changed");
	doc.flash_message(_("The scale was applied"));
	return true;
}


/*
 *
 */
SubtitleTime Scale::calcul(
		const SubtitleTime &source, double scale,
		const SubtitleTime &sourcedisp, const SubtitleTime &destdisp)
{
	return (source + (((source - sourcedisp) * scale) + (destdisp - sourcedisp)));
}

/*
 *
 */
double Scale::calcul_scale(long source1, long dest1, long source2, long dest2)
{
	return (double)(((dest2 - source2) - (dest1 - source1)) / (double)(source2 - source1));
}

