#include "JoinDocumentUI.h"
#include "OpenDocumentUI.h"
#include "DocumentSystem.h"

/*
 *
 */
void JoinDocumentUI::execute()
{
	Document *doc = DocumentSystem::getInstance().getCurrentDocument();
	
	g_return_if_fail(doc);

	OpenDocumentUI ui;
	ui.set_select_multiple(false);
	
	if(ui.run() == Gtk::RESPONSE_OK)
	{
		Glib::ustring ofile = doc->getFilename();
		Glib::ustring oformat = doc->getFormat();
		Glib::ustring ocharset = doc->getCharset();

		Glib::ustring filename = ui.get_filename();
		Glib::ustring format = ui.getFormat();
		Glib::ustring encoding = ui.getEncoding();

		if(doc->open(filename));
		{
			doc->get_subtitle_model()->rebuild_column_num();
		}

		doc->setFilename(ofile);
		doc->setFormat(oformat);
		doc->setCharset(ocharset);
	}
}
