#ifndef _WaveformGeneratorUI_h
#define _WaveformGeneratorUI_h

#include <gtkmm.h>
#include <gst/gst.h>
#include "Waveform.h"

class WaveformGeneratorUI : public Gtk::Dialog
{
public:
	WaveformGeneratorUI(Glib::RefPtr<Waveform> &waveform, const Glib::ustring &uri);
	~WaveformGeneratorUI();

protected:
	
	/*
	 *
	 */
	bool bus_message(GstBus *bus, GstMessage *message);
	
	void newpad(GstElement *decodebin, GstPad *pad, gboolean last);
	/*
	 *
	 */
	static gboolean __static_bus_message(GstBus *bus, GstMessage *message, gpointer data);
	static void __static_newpad(GstElement* decodebin, GstPad *pad, gboolean last, gpointer data);

	/*
	 *
	 */
	bool on_timeout();
protected:
	
	Gtk::ProgressBar	m_progressbar;
	GstElement* m_pipeline;
	GstBus* m_bus;
	Glib::RefPtr<Waveform> m_waveform;
	gint64	m_duration;
	GstClockTime	endtime;

	GstElement *m_audio;
	GstElement *m_src;
	GstElement *m_dec;
	GstElement *m_conv;
	GstElement *m_lev;
	GstElement *m_sink;
};

#endif//_WaveformGeneratorUI_h

